﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace UltraComboHierarchicalDropDown
{
    public partial class CustomCombo : UserControl
    {

        private int dropDownHeight = 150;
        public int DropDownHeight
        {
            get { return dropDownHeight; }
            set { dropDownHeight = value; }
        }
        private DataSet dataSet;

        public DataSet DataSet
        {
            get { return dataSet; }
            set 
            {
                if (value == null && value == dataSet) return;
                ultraGrid1.DataSource = value;
                dataSet = value; 
            }

        }

        public CustomCombo()
        {
            InitializeComponent();
            this.ultraCombo1.BeforeDropDown += new CancelEventHandler(ultraCombo1_BeforeDropDown);
            this.ultraGrid1.MouseDoubleClick += new MouseEventHandler(ultraGrid1_MouseDoubleClick);
            this.ultraGrid1.DoubleClick += new EventHandler(ultraGrid1_DoubleClick);
            this.ultraGrid1.DisplayLayout.Override.CellClickAction = Infragistics.Win.UltraWinGrid.CellClickAction.RowSelect;
        }


        void ultraGrid1_DoubleClick(object sender, EventArgs e)
        {
            SelectedItem();
        }

        void ultraGrid1_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            SelectedItem();
        }

        void ultraCombo1_BeforeDropDown(object sender, CancelEventArgs e)
        {
            e.Cancel = true;
            this.Height = this.dropDownHeight;
            this.Size = new Size(this.Width, this.dropDownHeight);
            ultraGrid1.Dock = DockStyle.Fill;
        }

        void SelectedItem()
        {
            if (ultraGrid1.ActiveRow.Cells == null) return;
            this.ultraCombo1.Value = ultraGrid1.ActiveRow.Cells[0].Text;
            this.Height = this.ultraCombo1.Height;
        }
    }
}
